#include<iostream>
#include<string>
using namespace std;

class Evaluation{
	private:
		int ratedNum;		// number of T
		double average;		// score
		string ID;
		int* rating;		// rating others
		int* rated;			// being rated		
	public:
		Evaluation();
		Evaluation(string userID);
		string getID();
		int getTradeNum();
		double getScore();
		void transaction(int evaluation, int evaluated);
};

int main(){
	string option, cusID, merID, prodID, temp;
	int cusRate, merRate;
	int cusNum = 0, merNum = 0, rateNum = 1;
	bool isUsed = 0;
	Evaluation* customer;
	Evaluation* merchant;
	Evaluation swap;
	
	while(cin >> option){
		if(option == "C"){
			cin >> cusID;
			// check whether the customer already existed
			isUsed = 0;
			for(int i = 0; i < cusNum; i++){
				if(cusID == customer[i].getID()){
					isUsed = 1;
					break;
				}
			}
			if(isUsed == 0){
				// if the customer is new
				Evaluation* a = customer;					// construct a temp array stores data in original array
				customer = new Evaluation[cusNum+1];		// put the original n-array to n+1-array
				for(int i = 0; i < cusNum; i++){			// copy data to n+1 array
					customer[i] = a[i];
				}
				Evaluation newEva = Evaluation(cusID);		// put the new customer info to the last
				customer[cusNum] = newEva;
				if(cusNum != 0){
					delete[] a;									// release the memory space
				}
				cusNum++;
			}
		}
		// do all the same thing as "C"
		else if(option == "M"){
			cin >> merID;
			isUsed = 0;
			for(int i = 0; i < merNum; i++){
				if(merID == merchant[i].getID()){
					isUsed = 1;
					break;
				}
			}
			if(isUsed == 0){
				Evaluation* a = merchant;
				merchant = new Evaluation[merNum+1];
				for(int i = 0; i < merNum; i++){
					merchant[i] = a[i];
				}
				Evaluation newEva = Evaluation(merID);
				merchant[merNum] = newEva;
				if(merNum != 0){
					delete[] a;	
				}
				merNum++;
			}
		}
		else if(option == "T"){
			cin >> cusID >> merID >> prodID >> cusRate >> merRate;
			for(int i = 0; i < cusNum; i++){
				if(customer[i].getID() == cusID){
					customer[i].transaction(cusRate, merRate);	// stores 1.the score he rates others 2.the score he gets
				}
			}
			for(int i = 0; i < merNum; i++){
				if(merchant[i].getID() == merID){
					merchant[i].transaction(merRate, cusRate);
				}
			}
		}
		else if(option == "S"){
			int n, p;
			cin >> cusID >> prodID;
			// get the third number
			getline(cin,temp);
			rateNum = 1;
			if(temp != ""){
				rateNum = stoi(temp);
			}
			//bubble sort according to merchant's score -> evaNum -> name
			for(int i = merNum-1; i > 0 ; i--){
				for(int j = 0; j < i; j++){
					//isUsed = 0;
					if(merchant[j].getScore() > merchant[j+1].getScore()){
					}	
					else if(merchant[j].getScore() == merchant[j+1].getScore() && 
							merchant[j].getTradeNum() > merchant[j+1].getTradeNum()){
					}
					else if(merchant[j].getScore() == merchant[j+1].getScore() && 
							merchant[j].getTradeNum() == merchant[j+1].getTradeNum() &&
							merchant[j].getID() < merchant[j+1].getID()){
					}
					else{
						swap = merchant[j];
						merchant[j] = merchant[j+1];
						merchant[j+1] = swap;	
					} 
					
				}
			}
			int rank = 5;
			for(int i = 0; i < merNum; i++){
				if(merchant[i].getTradeNum() >= rateNum){
					if(rank != 5){
						cout << " ";
					}
					cout << merchant[i].getID();
					rank--;
					if(rank == 0)
						break;
				}
			}
			cout << endl;
		}
		else{
		}
	}
	return 0;
}

Evaluation::Evaluation(){
	this->average = 0;
	this->ratedNum = 0;
}
Evaluation::Evaluation(string userID){
	this->ID = userID;
	this->ratedNum = 0;
	this->rating = NULL;
	this->rated = NULL;
}
string Evaluation::getID(){
	return ID;
}
int Evaluation::getTradeNum(){
	return ratedNum;
}
double Evaluation::getScore(){
	if(this->ratedNum == 0)
		return 0.0;
	double temp = 0;
	for(int i = 0; i < this->ratedNum; i++){
		temp += this->rated[i];
	}
	this->average = temp/this->ratedNum;
	return this->average;
}
void Evaluation::transaction(int evaluation, int evaluated){	
	int* tempRating = this->rating;
	int* tempRated = this->rated;
	this->rating = new int[this->ratedNum+1];
	this->rated = new int[this->ratedNum+1];	
	if(this->ratedNum != 0){
		for(int i = 0; i < this->ratedNum; i++){
			this->rating[i] = tempRating[i];
			this->rated[i] = tempRated[i];
		}
	}
	this->rating[this->ratedNum] = evaluation;
	this->rated[this->ratedNum] = evaluated;
	this->ratedNum++;
	delete[] tempRating;
	delete[] tempRated;
}
